Subject: Re: [PATCH] Add Documentation/CodingStyle

From: Andreas Ericsson <[email-masked]>
Date: Wed, 07 Nov 2007 09:52:39 +0100

Junio C Hamano wrote:
> Johannes Schindelin <[email-masked]> writes:
> 
>> diff --git a/Documentation/CodingStyle b/Documentation/CodingStyle
>> new file mode 100644
>> index 0000000..622b80b
>> --- /dev/null
>> +++ b/Documentation/CodingStyle
>> @@ -0,0 +1,87 @@
>> +As a popular project, we also have some guidelines to keep to the
>> +code.  For git in general, two rough rules are:
>> +
>> + - Most importantly, we never say "It's in POSIX; we'll happily
>> +   screw your system that does not conform."  We live in the
>> +   real world.
>> +
>> + - However, we often say "Let's stay away from that construct,
>> +   it's not even in POSIX".
>> +
> 
> I am not sure if we want to have CodingStyle document, but the
> above are not CodingStyle issues.
> 
> If we are to write this down, I'd like to have the more
> important third rule, which is:
> 
>  - In spite of the above two rules, we sometimes say "Although
>    this is not in POSIX, it (is so convenient | makes the code
>    much more readable | has other good characteristics) and
>    practically all the platforms we care about support it, so
>    let's use it".  Again, we live in the real world, and it is
>    sometimes a judgement call, decided based more on real world
>    constraints people face than what the paper standard says.
> 
>> +For C programs:
>> +
>> + - Use tabs to increment, and interpret tabs as taking up to 8 spaces
> 
> What's the character for decrement?  DEL? ;-)
> 
>> +   Double negation is often harder to understand than no negation at
>> +   all.
>> +
>> +   Some clever tricks, like using the !! operator with arithmetic
>> +   constructs, can be extremely confusing to others.  Avoid them,
>> +   unless there is a compelling reason to use them.
> 
> I actually think (!!var) idiom is already established in our
> codebase.
> 

Not very widely for arithmetic expressions though. I believe this
alludes to the (!!a + !!b + !!c) idiom used earlier, where it's not
exactly clear *why* a, b and c can be > 1 if != 0 is the only thing
we care about.

>> + - Use the API.  No, really.  We have a strbuf (variable length string),
>> +   several arrays with the ALLOC_GROW() macro, a path_list for sorted
>> +   string lists, a hash map (mapping struct objects) named
>> +   "struct decorate", amongst other things.
> 
>  - When you come up with an API, document it.
> 
>> + - if you are planning a new command, consider writing it in shell or
>> +   perl first, so that changes in semantics can be easily changed and
>> +   discussed.  Many git commands started out like that, and a few are
>> +   still scripts.
> 
> No Python allowed?

Perhaps with this addendum?

- Think very, very hard before introducing a new dependency into git. This
  means you should stay away from scripting languages not already used in
  the git core command set unless your command is clearly separate from it,
  such as an importer to convert random-scm-X repositories to git.

-- 
Andreas Ericsson                   [email-masked]
OP5 AB                             www.op5.se
Tel: +46 8-230225                  Fax: +46 8-230231